################################################################
# Direct function call from the player_interacted_with_entity
# advancement for hitboxes.
#
# Specification of the advancement only allows the function to
# be called as the player who earned the advancement!
# Find all interactions associated with a hitbox that were
# interacted with and call their subroutine as the data marker.
#
#
# @as = player
# @at = nd
################################################################


# Cache the UUID of the initiator
function uf_api:.data/.player/.get/uuid
data modify storage uf_entity:hitbox on_interact.initiator set from storage uf_data:player UUID

execute as @e[type=minecraft:interaction, tag=UF_ENTITY.hitbox.on_interact] \
  if data entity @s interaction \
  on passengers \
  run function uf_entity:.c_entity/.hitbox/.on_interact/sub \
    with entity @s data

# Revoke the advancement for the player that initiated the update
advancement revoke @s only uf_entity:.hitbox/on_interact